/* Automaticaly generated by ll.c */
/* Do not edit */ 
/* Copyright (C) 2003 Michal Conos */
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_STRING_H
#  include <string.h>
#endif

static int input;


static void read_next_char(void) 
{
	input = getchar();
	printf("\n" __FUNCTION__ ":got %c\n", (char)input);
	if ( (char)input == '\n' ) {
		printf("Ok, parsed.\n");
	}
}

static void compare( int c )
{
	if ( input == c ) {
		read_next_char();
	} else {
		fprintf(stderr,"Error in input! Can't analyze!\n");
		exit( EXIT_FAILURE );
	}
}


/*

Read rules:

(1) S -> A=S
(2) A -> PC
(3) A -> !PC
(4) C -> aPC
(5) C -> oPC
(6) C -> xPC
(7) C -> qPC
(8) C -> hPC
(9) C -> mPC
(10) C -> gPC
(11) C -> tPC
(12) C -> e
(13) P -> BQ
(14) P -> -BQ
(15) Q -> +BQ
(16) Q -> -BQ
(17) Q -> e
(18) B -> MD
(19) B -> ~MD
(20) D -> lMD
(21) D -> rMD
(22) D -> &MD
(23) D -> ^MD
(24) D -> e
(25) M -> FN
(26) N -> *FN
(27) N -> dFN
(28) N -> %FN
(29) N -> e
(30) F -> n
(31) F -> (A)
lsym=S
lsym=S
lsym=S
lsym=S
lsym=S
lsym=A
lsym=A
lsym=A
lsym=A
lsym=A
lsym=C
lsym=C
lsym=C
lsym=C
lsym=C
lsym=C
lsym=C
lsym=C
lsym=C
lsym=P
lsym=P
lsym=P
lsym=P
lsym=Q
lsym=Q
lsym=Q
lsym=B
lsym=B
lsym=B
lsym=D
lsym=D
lsym=D
lsym=D
lsym=D
lsym=M
lsym=M
lsym=N
lsym=N
lsym=N
lsym=N
lsym=F
lsym=F


FIRST TABLE:
(S) : n(~-!
(A) : n(~-!
(C) : aoxqhmgte
(P) : n(~-
(Q) : +-e
(B) : n(~
(D) : lr&^e
(M) : n(
(N) : *d%e
(F) : n(


FOLLOW TABLE:
(S) : 
(A) : e=)
(C) : e=)
(P) : eaoxqhmgt=)
(Q) : eaoxqhmgt=)
(B) : e+-aoxqhmgt=)
(D) : e+-aoxqhmgt=)
(M) : elr&^+-aoxqhmgt=)
(N) : elr&^+-aoxqhmgt=)
(F) : e*d%lr&^+-aoxqhmgt=)
*/
void function_S(void);
void function_A(void);
void function_C(void);
void function_P(void);
void function_Q(void);
void function_B(void);
void function_D(void);
void function_M(void);
void function_N(void);
void function_F(void);

/* Select rules: */


void function_S( void )
{
	switch (input) {
		case 'n':
		case '(':
		case '~':
		case '-':
		case '!':
		/* (1) S -> A=S	 [n(~-!] */
			printf(" (1) S -> A=S	 [n(~-!] \n");
			function_A();
			compare( (int)'=' );
			function_S();
			break;
		default:
			fprintf(stderr, "Input parse error!\n");
			exit( EXIT_FAILURE );
	}
}

void function_A( void )
{
	switch (input) {
		case 'n':
		case '(':
		case '~':
		case '-':
		/* (2) A -> PC	 [n(~-] */
			printf(" (2) A -> PC	 [n(~-] \n");
			function_P();
			function_C();
			break;
		case '!':
		/* (3) A -> !PC	 [!] */
			printf(" (3) A -> !PC	 [!] \n");
			compare( (int)'!' );
			function_P();
			function_C();
			break;
		default:
			fprintf(stderr, "Input parse error!\n");
			exit( EXIT_FAILURE );
	}
}

void function_C( void )
{
	switch (input) {
		case 'a':
		/* (4) C -> aPC	 [a] */
			printf(" (4) C -> aPC	 [a] \n");
			compare( (int)'a' );
			function_P();
			function_C();
			break;
		case 'o':
		/* (5) C -> oPC	 [o] */
			printf(" (5) C -> oPC	 [o] \n");
			compare( (int)'o' );
			function_P();
			function_C();
			break;
		case 'x':
		/* (6) C -> xPC	 [x] */
			printf(" (6) C -> xPC	 [x] \n");
			compare( (int)'x' );
			function_P();
			function_C();
			break;
		case 'q':
		/* (7) C -> qPC	 [q] */
			printf(" (7) C -> qPC	 [q] \n");
			compare( (int)'q' );
			function_P();
			function_C();
			break;
		case 'h':
		/* (8) C -> hPC	 [h] */
			printf(" (8) C -> hPC	 [h] \n");
			compare( (int)'h' );
			function_P();
			function_C();
			break;
		case 'm':
		/* (9) C -> mPC	 [m] */
			printf(" (9) C -> mPC	 [m] \n");
			compare( (int)'m' );
			function_P();
			function_C();
			break;
		case 'g':
		/* (10) C -> gPC	 [g] */
			printf(" (10) C -> gPC	 [g] \n");
			compare( (int)'g' );
			function_P();
			function_C();
			break;
		case 't':
		/* (11) C -> tPC	 [t] */
			printf(" (11) C -> tPC	 [t] \n");
			compare( (int)'t' );
			function_P();
			function_C();
			break;
		case EOF:
		case '\n':
		case '=':
		case ')':
		/* (12) C -> e	 [e=)] */
			printf(" (12) C -> e	 [e=)] \n");
			break;
		default:
			fprintf(stderr, "Input parse error!\n");
			exit( EXIT_FAILURE );
	}
}

void function_P( void )
{
	switch (input) {
		case 'n':
		case '(':
		case '~':
		/* (13) P -> BQ	 [n(~] */
			printf(" (13) P -> BQ	 [n(~] \n");
			function_B();
			function_Q();
			break;
		case '-':
		/* (14) P -> -BQ	 [-] */
			printf(" (14) P -> -BQ	 [-] \n");
			compare( (int)'-' );
			function_B();
			function_Q();
			break;
		default:
			fprintf(stderr, "Input parse error!\n");
			exit( EXIT_FAILURE );
	}
}

void function_Q( void )
{
	switch (input) {
		case '+':
		/* (15) Q -> +BQ	 [+] */
			printf(" (15) Q -> +BQ	 [+] \n");
			compare( (int)'+' );
			function_B();
			function_Q();
			break;
		case '-':
		/* (16) Q -> -BQ	 [-] */
			printf(" (16) Q -> -BQ	 [-] \n");
			compare( (int)'-' );
			function_B();
			function_Q();
			break;
		case EOF:
		case '\n':
		case 'a':
		case 'o':
		case 'x':
		case 'q':
		case 'h':
		case 'm':
		case 'g':
		case 't':
		case '=':
		case ')':
		/* (17) Q -> e	 [eaoxqhmgt=)] */
			printf(" (17) Q -> e	 [eaoxqhmgt=)] \n");
			break;
		default:
			fprintf(stderr, "Input parse error!\n");
			exit( EXIT_FAILURE );
	}
}

void function_B( void )
{
	switch (input) {
		case 'n':
		case '(':
		/* (18) B -> MD	 [n(] */
			printf(" (18) B -> MD	 [n(] \n");
			function_M();
			function_D();
			break;
		case '~':
		/* (19) B -> ~MD	 [~] */
			printf(" (19) B -> ~MD	 [~] \n");
			compare( (int)'~' );
			function_M();
			function_D();
			break;
		default:
			fprintf(stderr, "Input parse error!\n");
			exit( EXIT_FAILURE );
	}
}

void function_D( void )
{
	switch (input) {
		case 'l':
		/* (20) D -> lMD	 [l] */
			printf(" (20) D -> lMD	 [l] \n");
			compare( (int)'l' );
			function_M();
			function_D();
			break;
		case 'r':
		/* (21) D -> rMD	 [r] */
			printf(" (21) D -> rMD	 [r] \n");
			compare( (int)'r' );
			function_M();
			function_D();
			break;
		case '&':
		/* (22) D -> &MD	 [&] */
			printf(" (22) D -> &MD	 [&] \n");
			compare( (int)'&' );
			function_M();
			function_D();
			break;
		case '^':
		/* (23) D -> ^MD	 [^] */
			printf(" (23) D -> ^MD	 [^] \n");
			compare( (int)'^' );
			function_M();
			function_D();
			break;
		case EOF:
		case '\n':
		case '+':
		case '-':
		case 'a':
		case 'o':
		case 'x':
		case 'q':
		case 'h':
		case 'm':
		case 'g':
		case 't':
		case '=':
		case ')':
		/* (24) D -> e	 [e+-aoxqhmgt=)] */
			printf(" (24) D -> e	 [e+-aoxqhmgt=)] \n");
			break;
		default:
			fprintf(stderr, "Input parse error!\n");
			exit( EXIT_FAILURE );
	}
}

void function_M( void )
{
	switch (input) {
		case 'n':
		case '(':
		/* (25) M -> FN	 [n(] */
			printf(" (25) M -> FN	 [n(] \n");
			function_F();
			function_N();
			break;
		default:
			fprintf(stderr, "Input parse error!\n");
			exit( EXIT_FAILURE );
	}
}

void function_N( void )
{
	switch (input) {
		case '*':
		/* (26) N -> *FN	 [*] */
			printf(" (26) N -> *FN	 [*] \n");
			compare( (int)'*' );
			function_F();
			function_N();
			break;
		case 'd':
		/* (27) N -> dFN	 [d] */
			printf(" (27) N -> dFN	 [d] \n");
			compare( (int)'d' );
			function_F();
			function_N();
			break;
		case '%':
		/* (28) N -> %FN	 [%] */
			printf(" (28) N -> %FN	 [%] \n");
			compare( (int)'%' );
			function_F();
			function_N();
			break;
		case EOF:
		case '\n':
		case 'l':
		case 'r':
		case '&':
		case '^':
		case '+':
		case '-':
		case 'a':
		case 'o':
		case 'x':
		case 'q':
		case 'h':
		case 'm':
		case 'g':
		case 't':
		case '=':
		case ')':
		/* (29) N -> e	 [elr&^+-aoxqhmgt=)] */
			printf(" (29) N -> e	 [elr&^+-aoxqhmgt=)] \n");
			break;
		default:
			fprintf(stderr, "Input parse error!\n");
			exit( EXIT_FAILURE );
	}
}

void function_F( void )
{
	switch (input) {
		case 'n':
		/* (30) F -> n	 [n] */
			printf(" (30) F -> n	 [n] \n");
			compare( (int)'n' );
			break;
		case '(':
		/* (31) F -> (A)	 [(] */
			printf(" (31) F -> (A)	 [(] \n");
			compare( (int)'(' );
			function_A();
			compare( (int)')' );
			break;
		default:
			fprintf(stderr, "Input parse error!\n");
			exit( EXIT_FAILURE );
	}
}

int main(void){
	read_next_char();

	function_S();
	return EXIT_SUCCESS;
}

