/*
 * Miscelaneous utitlity functions such as `make_lowecase()' which 
 * converts the specified string to lowecase. It uses the ANSI C
 * function `tolower()'.
 *
 * Copyright (c) 2001 MIKC Psycho - TIC
 */

#include <stdio.h>
#include <stdlib.h>

#ifdef HAVE_STRING_H
#  include <string.h>
#endif

#include <ctype.h>

#include "utility.h"

char **xstrcat( char **dest, const char *src, size_t *act_dest_size )
{
	if ( strlen(*dest) + strlen(src) + 1 >= *act_dest_size ) {
		*act_dest_size <<= 1;
		*dest = realloc( *dest, *act_dest_size );
		if  (! *dest ) {
			perror( __FILE__ __FUNCTION__ );
			exit( EXIT_FAILURE );
		}
	}

	strcat( *dest, src );

	return dest;
}

void *xrealloc( void *ptr, size_t size )
{
	void *r = realloc( ptr, size );
	if ( !r ) {
		perror( __FILE__ __FUNCTION__ );
		exit( EXIT_FAILURE );
	}

	return r;
}


void *xcalloc( size_t nmemb, size_t size )
{
	void *r = calloc( nmemb, size );
	if ( !r ) {
		perror( __FILE__ __FUNCTION__ );
		exit( EXIT_FAILURE );
	}

	return r;
}


char *xstrdup( char *s )
{
	char *r = strdup(s);
	if ( !r ) {
		perror( __FILE__ __FUNCTION__ );
		exit( EXIT_FAILURE );
	}

	return r;
}


/* makes `s' lowercase */
char *make_lowercase(char *s) 
{
	char *tmp = s;

	if ( !s ) return NULL;
	while (*s) {
		*s = ( char ) tolower (*s);
		s++;
	}

	return tmp;
}

char *ltrim (char *s)
{
	char *dummy = s;
	size_t nbytes = 0;
	size_t orig_len;

	
	if ( !s ) return NULL;
	
	orig_len = strlen (s);

	while ( isspace(*dummy) ) dummy++, nbytes++; 

	memmove (s, dummy, strlen (dummy));
	s[orig_len - nbytes] = '\0';

	return s;
}

char *rtrim (char *s)
{
	char *dummy ;
	int orig_len;
	
	if ( !s ) return NULL;
	orig_len = strlen(s);

	dummy = s;
	dummy += orig_len;
	dummy--;
	
	while ( isspace (*dummy) ) {
		*dummy = '\0';
		dummy--;
	}

	return s;
}

char *delete_spaces (char *s)
{
	if ( !s ) return NULL;
	s = ltrim (s);
	s = rtrim (s);
	
	return s;
}

