#ifndef _NODE_H_
#define _NODE_H_


#include <lex.h>

class VarValue {
	public:
		VarValue(double num);
		VarValue(char *s);
		~VarValue();
		char * strval;
		double numval;
};

class Node {
	public:
		virtual VarValue *getValue() = 0;
		virtual lexsym_t  getType() = 0;
};

class BinOp : public Node {
	public:
		BinOp( lexsym_t op, Node *left, Node *right );
		~BinOp();
		virtual VarValue *getValue();
		virtual lexsym_t  getType() = 0;
	private:
		Node *l, *r;
		lexsym_t op;
		VarValue * make_on_strings( lexsym_t op, Node *l, Node *r );
		VarValue * make_on_numbers( lexsym_t op, Node *l, Node *r );
		
};

class UnOp : public Node {
	public:
		UnOp( lexsym_t op, Node *node );
		~UnOp();
		virtual VarValue *getValue();
		virtual lexsym_t  getType() = 0;
	private:
		Node *n;
		lexsym_t op;
		VarValue * make_on_numbers( lexsym_t op, Node *node );
};

class DoubleVarOrConst : public Node {
	public:
		DoubleVarOrConst( lexsym_t type, char *name );
		DoubleVarOrConst( lexsym_t type, double value );
		~DoubleVarOrConst();
		virtual VarValue *getValue();
		virtual lexsym_t  getType() = 0;
	private:
		VarValue *val;
		lexsym_t type;
};


#endif
