/*  Variable storage of MIKC language
 *  Copyright (C) 2003 Michal Conos
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>

#include <lex.h>
#include <var.h>

#include <mystring.h>


/* String concatenation. s1 concatenated with s2, new string is created and
   returned as s */
char *
add_string( char *s1, char *s2 )
{
	size_t len;
	char *s;
	
	if ( !s1 || !s2 ) {
		fprintf( stderr, __FILE__ ": s1 or/and s2 is/are NULL!\n" );
		exit ( EXIT_FAILURE );
	}

	len = strlen(s1) + strlen(s2) + 1;
	if ( ( s = (char*) malloc( len ) ) == NULL ) {
		perror( __FILE__ ": malloc()" );
		exit( EXIT_FAILURE );
	}
	
	strcpy( s, s1 );
	strcat( s, s2 );
	s[len-1] = '\0';
	
	return s;	
}

/* String assign, new string is created and returned as s */
char *
assign_string( char *s1 )
{
	size_t len;
	char *s;
	
	if ( !s1 ) {
		fprintf( stderr, __FILE__ ": s = NULL !\n" );
		exit( EXIT_FAILURE );
	}

	len = strlen( s1 ) + 1;
	
	if ( ( s = (char*) malloc( len ) ) == NULL ) {
		perror( __FILE__ ": malloc()" );
		exit( EXIT_FAILURE );
	}
	
	strcpy( s, s1 );
	s[len-1] = '\0';
	
	return s;	
}
	

