#ifndef _VAR_H_
#define _VAR_H_


typedef enum {
	NUMBER, STRING
} var_t;

struct VarInfo {
	int   free;
	var_t vartype;
	char *varname;
	union {
		char   *strval;
		double  numval;
	};
};


#define DEFAULTSPACE 1000

typedef enum {
	STORE, GET
} opmode_t;


class VarStorage {
	public:
		VarStorage(int space);
		VarStorage();
		~VarStorage();
		void storeVariable( char * varname, double value );
		void storeVariable( char * varname, char * value );
		struct VarInfo * getVariable( char *varname );
		int getAddr( char *varname );
	private:
		struct VarInfo *varstorage;
		int varspace;
		int stored_num;
		int actpos;
		int hash( char *s, opmode_t opmode );
		void init_service();
};


#endif
